diff --git a/doc/filters.texi b/doc/filters.texi
index 2fb0212bdf..b200589373 100644
--- a/doc/filters.texi
+++ b/doc/filters.texi
@@ -7315,6 +7315,25 @@ ffmpeg -f lavfi -i color=c=black:s=1280x720 -i video.mp4 -shortest -filter_compl
 @end example
 @end itemize
 
+@section chromanr
+Reduce chrominance noise.
+
+The filter accepts the following options:
+
+@table @option
+@item thres
+Set threshold for averaging chrominance values.
+Sum of absolute difference of U and V pixel components or current
+pixel and neighbour pixels lower than this threshold will be used in
+averaging. Luma component is left unchanged and is copied to output.
+
+@item sizew
+Set horizontal radius of rectangle used for averaging.
+
+@item sizeh
+Set vertical radius of rectangle used for averaging.
+@end table
+
 @section chromashift
 Shift chroma pixels horizontally and/or vertically.
 
diff --git a/libavfilter/Makefile b/libavfilter/Makefile
index 6440794bcf..33dcc69392 100644
--- a/libavfilter/Makefile
+++ b/libavfilter/Makefile
@@ -183,6 +183,7 @@ OBJS-$(CONFIG_CAS_FILTER)                    += vf_cas.o
 OBJS-$(CONFIG_CHROMABER_VULKAN_FILTER)       += vf_chromaber_vulkan.o vulkan.o
 OBJS-$(CONFIG_CHROMAHOLD_FILTER)             += vf_chromakey.o
 OBJS-$(CONFIG_CHROMAKEY_FILTER)              += vf_chromakey.o
+OBJS-$(CONFIG_CHROMANR_FILTER)               += vf_chromanr.o
 OBJS-$(CONFIG_CHROMASHIFT_FILTER)            += vf_chromashift.o
 OBJS-$(CONFIG_CIESCOPE_FILTER)               += vf_ciescope.o
 OBJS-$(CONFIG_CODECVIEW_FILTER)              += vf_codecview.o
diff --git a/libavfilter/allfilters.c b/libavfilter/allfilters.c
index 65669c4422..b896a76c9e 100644
--- a/libavfilter/allfilters.c
+++ b/libavfilter/allfilters.c
@@ -173,6 +173,7 @@ extern AVFilter ff_vf_bwdif;
 extern AVFilter ff_vf_cas;
 extern AVFilter ff_vf_chromahold;
 extern AVFilter ff_vf_chromakey;
+extern AVFilter ff_vf_chromanr;
 extern AVFilter ff_vf_chromashift;
 extern AVFilter ff_vf_ciescope;
 extern AVFilter ff_vf_codecview;
diff --git a/libavfilter/vf_chromanr.c b/libavfilter/vf_chromanr.c
new file mode 100644
index 0000000000..6e85262ff6
--- /dev/null
+++ b/libavfilter/vf_chromanr.c
@@ -0,0 +1,211 @@
+/*
+ * Copyright (c) 2020 Paul B Mahol
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "libavutil/avstring.h"
+#include "libavutil/imgutils.h"
+#include "libavutil/opt.h"
+#include "libavutil/pixdesc.h"
+
+#include "avfilter.h"
+#include "formats.h"
+#include "internal.h"
+#include "video.h"
+
+typedef struct ChromaNRContext {
+    const AVClass *class;
+
+    int thres;
+    int sizew;
+    int sizeh;
+    int depth;
+    int nb_planes;
+    int linesize[4];
+    int planeheight[4];
+    int planewidth[4];
+
+    AVFrame *out;
+    int (*filter_slice)(AVFilterContext *ctx, void *arg, int jobnr, int nb_jobs);
+} ChromaNRContext;
+
+static int query_formats(AVFilterContext *ctx)
+{
+    static const enum AVPixelFormat pix_fmts[] = {
+        AV_PIX_FMT_YUVA444P, AV_PIX_FMT_YUVA422P, AV_PIX_FMT_YUVA420P,
+        AV_PIX_FMT_YUVJ444P, AV_PIX_FMT_YUVJ440P, AV_PIX_FMT_YUVJ422P,AV_PIX_FMT_YUVJ420P, AV_PIX_FMT_YUVJ411P,
+        AV_PIX_FMT_YUV444P, AV_PIX_FMT_YUV440P, AV_PIX_FMT_YUV422P, AV_PIX_FMT_YUV420P, AV_PIX_FMT_YUV411P, AV_PIX_FMT_YUV410P,
+        AV_PIX_FMT_NONE
+    };
+
+    AVFilterFormats *fmts_list = ff_make_format_list(pix_fmts);
+    if (!fmts_list)
+        return AVERROR(ENOMEM);
+    return ff_set_common_formats(ctx, fmts_list);
+}
+
+static int filter_slice8(AVFilterContext *ctx, void *arg, int jobnr, int nb_jobs)
+{
+    ChromaNRContext *s = ctx->priv;
+    AVFrame *in = arg;
+    AVFrame *out = s->out;
+    const int in_ulinesize = in->linesize[1];
+    const int in_vlinesize = in->linesize[2];
+    const int out_ulinesize = out->linesize[1];
+    const int out_vlinesize = out->linesize[2];
+    const int sizew = s->sizew;
+    const int sizeh = s->sizeh;
+    const int thres = s->thres;
+    const int h = s->planeheight[1];
+    const int w = s->planewidth[1];
+    const int slice_start = (h * jobnr) / nb_jobs;
+    const int slice_end = (h * (jobnr+1)) / nb_jobs;
+    uint8_t *out_uptr = out->data[1] + slice_start * out_ulinesize;
+    uint8_t *out_vptr = out->data[2] + slice_start * out_vlinesize;
+
+    {
+        const int h = s->planeheight[0];
+        const int w = s->planewidth[0];
+        const int slice_start = (h * jobnr) / nb_jobs;
+        const int slice_end = (h * (jobnr+1)) / nb_jobs;
+
+        av_image_copy_plane(out->data[0] + slice_start * out->linesize[0],
+                            out->linesize[0],
+                            in->data[0] + slice_start * in->linesize[0],
+                            in->linesize[0],
+                            w, slice_end - slice_start);
+    }
+
+    for (int y = slice_start; y < slice_end; y++) {
+        const uint8_t *in_uptr = in->data[1] + y * in_ulinesize;
+        const uint8_t *in_vptr = in->data[2] + y * in_vlinesize;
+
+        for (int x = 0; x < w; x++) {
+            const int cu = in_uptr[x];
+            const int cv = in_vptr[x];
+            int su = 0;
+            int sv = 0;
+            int cn = 0;
+
+            for (int yy = FFMAX(0, y - sizeh); yy < FFMIN(y + sizeh, h); yy++) {
+                const uint8_t *in_uptr = in->data[1] + yy * in_ulinesize;
+                const uint8_t *in_vptr = in->data[2] + yy * in_vlinesize;
+
+                for (int xx = FFMAX(0, x - sizew); xx < FFMIN(x + sizew, w); xx++) {
+                   const int u = in_uptr[xx];
+                   const int v = in_vptr[xx];
+
+                   if (FFABS(cu - u) + FFABS(cv - v) < thres) {
+                       su += u;
+                       sv += v;
+                       cn++;
+                   }
+                }
+            }
+
+            out_uptr[x] = su / cn;
+            out_vptr[x] = sv / cn;
+        }
+
+        out_uptr += out_ulinesize;
+        out_vptr += out_vlinesize;
+    }
+
+    return 0;
+}
+
+static int filter_frame(AVFilterLink *inlink, AVFrame *in)
+{
+    AVFilterContext *ctx = inlink->dst;
+    AVFilterLink *outlink = ctx->outputs[0];
+    ChromaNRContext *s = ctx->priv;
+    AVFrame *out;
+
+    out = ff_get_video_buffer(outlink, outlink->w, outlink->h);
+    if (!out) {
+        av_frame_free(&in);
+        return AVERROR(ENOMEM);
+    }
+
+    av_frame_copy_props(out, in);
+    s->out = out;
+    ctx->internal->execute(ctx, s->filter_slice, in, NULL,
+                           FFMIN3(s->planeheight[1],
+                                  s->planeheight[2],
+                                  ff_filter_get_nb_threads(ctx)));
+
+    av_frame_free(&in);
+    return ff_filter_frame(outlink, out);
+}
+
+static int config_input(AVFilterLink *inlink)
+{
+    AVFilterContext *ctx = inlink->dst;
+    ChromaNRContext *s = ctx->priv;
+    const AVPixFmtDescriptor *desc = av_pix_fmt_desc_get(inlink->format);
+
+    s->depth = desc->comp[0].depth;
+    s->filter_slice = filter_slice8;
+    s->planeheight[1] = s->planeheight[2] = AV_CEIL_RSHIFT(inlink->h, desc->log2_chroma_h);
+    s->planeheight[0] = s->planeheight[3] = inlink->h;
+    s->planewidth[1] = s->planewidth[2] = AV_CEIL_RSHIFT(inlink->w, desc->log2_chroma_w);
+    s->planewidth[0] = s->planewidth[3] = inlink->w;
+
+    return 0;
+}
+
+#define OFFSET(x) offsetof(ChromaNRContext, x)
+#define VF AV_OPT_FLAG_VIDEO_PARAM | AV_OPT_FLAG_FILTERING_PARAM
+
+static const AVOption chromanr_options[] = {
+    { "thres", "set u/v threshold",   OFFSET(thres), AV_OPT_TYPE_INT, {.i64=20}, 1, 511, VF },
+    { "sizew", "set horizontal size", OFFSET(sizew), AV_OPT_TYPE_INT, {.i64=5},  1,  20, VF },
+    { "sizeh", "set vertical size",   OFFSET(sizeh), AV_OPT_TYPE_INT, {.i64=5},  1,  20, VF },
+    { NULL }
+};
+
+static const AVFilterPad inputs[] = {
+    {
+        .name         = "default",
+        .type         = AVMEDIA_TYPE_VIDEO,
+        .filter_frame = filter_frame,
+        .config_props = config_input,
+    },
+    { NULL }
+};
+
+static const AVFilterPad outputs[] = {
+    {
+        .name = "default",
+        .type = AVMEDIA_TYPE_VIDEO,
+    },
+    { NULL }
+};
+
+AVFILTER_DEFINE_CLASS(chromanr);
+
+AVFilter ff_vf_chromanr = {
+    .name          = "chromanr",
+    .description   = NULL_IF_CONFIG_SMALL("Reduce chrominance noise."),
+    .priv_size     = sizeof(ChromaNRContext),
+    .priv_class    = &chromanr_class,
+    .query_formats = query_formats,
+    .outputs       = outputs,
+    .inputs        = inputs,
+    .flags         = AVFILTER_FLAG_SUPPORT_TIMELINE_GENERIC | AVFILTER_FLAG_SLICE_THREADS,
+};